#include "angband.h"
#include "cmd-spell.h"

/*!
* @brief JIẌ斂@̊es
* @param spell @ID
* @param mode e (SPELL_NAME / SPELL_DESC / SPELL_INFO / SPELL_CAST)
* @return SPELL_NAME / SPELL_DESC / SPELL_INFO ɂ͕|C^ԂBSPELL_CASTNULLԂB
*/
cptr do_chaos_spell(SPELL_IDX spell, BIT_FLAGS mode)
{
	bool name = (mode == SPELL_NAME) ? TRUE : FALSE;
	bool desc = (mode == SPELL_DESC) ? TRUE : FALSE;
	bool info = (mode == SPELL_INFO) ? TRUE : FALSE;
	bool cast = (mode == SPELL_CAST) ? TRUE : FALSE;

	static const char s_dam[] = _(":", "dam ");
	static const char s_random[] = _("_", "random");

	int dir;
	int plev = p_ptr->lev;

	switch (spell)
	{
	case 0:
		if (name) return _("}WbNE~TC", "Magic Missile");
		if (desc) return _("ア@̖B", "Fires a weak bolt of magic.");

		{
			int dice = 3 + ((plev - 1) / 5);
			int sides = 4;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_bolt_or_beam(beam_chance() - 10, GF_MISSILE, dir, damroll(dice, sides));
			}
		}
		break;

	case 1:
		if (name) return _("gbv/hAj", "Trap / Door Destruction");
		if (desc) return _("אڂ㩂Ɣj󂷂B", "Destroys all traps in adjacent squares.");

		{
			int rad = 1;

			if (info) return info_radius(rad);

			if (cast)
			{
				destroy_doors_touch();
			}
		}
		break;

	case 2:
		if (name) return _("M", "Flash of Light");
		if (desc) return _("Ƃ炵Ă͈͂Ŝivɖ邭B", "Lights up nearby area and the inside of a room permanently.");

		{
			int dice = 2;
			int sides = plev / 2;
			int rad = (plev / 10) + 1;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				lite_area(damroll(dice, sides), rad);
			}
		}
		break;

	case 3:
		if (name) return _("̎", "Touch of Confusion");
		if (desc) return _("Uł悤ɂB", "Attempts to confuse the next monster that you hit.");

		{
			if (cast)
			{
				if (!(p_ptr->special_attack & ATTACK_CONFUSE))
				{
					msg_print(_("Ȃ̎͌n߂B", "Your hands start glowing."));
					p_ptr->special_attack |= ATTACK_CONFUSE;
					p_ptr->redraw |= (PR_STATUS);
				}
			}
		}
		break;

	case 4:
		if (name) return _("y", "Mana Burst");
		if (desc) return _("@̋B", "Fires a ball of magic.");

		{
			int dice = 3;
			int sides = 5;
			int rad = (plev < 30) ? 2 : 3;
			int base;

			if (p_ptr->pclass == CLASS_MAGE ||
				p_ptr->pclass == CLASS_HIGH_MAGE ||
				p_ptr->pclass == CLASS_SORCERER)
				base = plev + plev / 2;
			else
				base = plev + plev / 4;


			if (info) return info_damage(dice, sides, base);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_MISSILE, dir, damroll(dice, sides) + base, rad);

				/*
				* Shouldn't actually use GF_MANA, as
				* it will destroy all items on the
				* floor
				*/
			}
		}
		break;

	case 5:
		if (name) return _("t@CAE{g", "Fire Bolt");
		if (desc) return _("̃{g̓r[B", "Fires a bolt or beam of fire.");

		{
			int dice = 8 + (plev - 5) / 4;
			int sides = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_bolt_or_beam(beam_chance(), GF_FIRE, dir, damroll(dice, sides));
			}
		}
		break;

	case 6:
		if (name) return _("͂̌", "Fist of Force");
		if (desc) return _("ȕ̋B", "Fires a tiny ball of disintegration.");

		{
			int dice = 8 + ((plev - 5) / 4);
			int sides = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_DISINTEGRATE, dir, damroll(dice, sides), 0);
			}
		}
		break;

	case 7:
		if (name) return _("e|[g", "Teleport Self");
		if (desc) return _("̃e|[gB", "Teleport long distance.");

		{
			POSITION range = plev * 5;

			if (info) return info_range(range);

			if (cast)
			{
				teleport_player(range, 0L);
			}
		}
		break;

	case 8:
		if (name) return _("_[", "Wonder");
		if (desc) return _("X^[Ƀ_Ȍʂ^B", "Fires something with random effects.");

		{
			if (info) return s_random;

			if (cast)
			{

				if (!get_aim_dir(&dir)) return NULL;

				cast_wonder(dir);
			}
		}
		break;

	case 9:
		if (name) return _("JIXE{g", "Chaos Bolt");
		if (desc) return _("JIX̃{g̓r[B", "Fires a bolt or ball of chaos.");

		{
			int dice = 10 + (plev - 5) / 4;
			int sides = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_bolt_or_beam(beam_chance(), GF_CHAOS, dir, damroll(dice, sides));
			}
		}
		break;

	case 10:
		if (name) return _("\jbNEu[", "Sonic Boom");
		if (desc) return _("𒆐SƂ̋𔭐B", "Generates a ball of sound centered on you.");

		{
			HIT_POINT dam = 60 + plev;
			int rad = plev / 10 + 2;

			if (info) return info_damage(0, 0, dam / 2);

			if (cast)
			{
				msg_print(_("h[IhꂽI", "BOOM! Shake the room!"));
				project(0, rad, p_ptr->y, p_ptr->x, dam, GF_SOUND, PROJECT_KILL | PROJECT_ITEM, -1);
			}
		}
		break;

	case 11:
		if (name) return _("jł̖", "Doom Bolt");
		if (desc) return _("Ȗ͂̃r[B", "Fires a beam of pure mana.");

		{
			int dice = 11 + (plev - 5) / 4;
			int sides = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_beam(GF_MANA, dir, damroll(dice, sides));
			}
		}
		break;

	case 12:
		if (name) return _("t@CAE{[", "Fire Ball");
		if (desc) return _("̋B", "Fires a ball of fire.");

		{
			HIT_POINT dam = plev + 55;
			int rad = 2;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_FIRE, dir, dam, rad);
			}
		}
		break;

	case 13:
		if (name) return _("e|[gEAEFC", "Teleport Other");
		if (desc) return _("X^[e|[gr[BRƖB", "Teleports all monsters on the line away unless resisted.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_beam(GF_AWAY_ALL, dir, power);
			}
		}
		break;

	case 14:
		if (name) return _("ǰt", "Word of Destruction");
		if (desc) return _("ӂ̃ACeAX^[An`j󂷂B", "Destroy everything in nearby area.");

		{
			int base = 12;
			int sides = 4;

			if (cast)
			{
				destroy_area(p_ptr->y, p_ptr->x, base + randint1(sides), FALSE);
			}
		}
		break;

	case 15:
		if (name) return _("OX", "Invoke Logrus");
		if (desc) return _("ȃJIX̋B", "Fires a huge ball of chaos.");

		{
			HIT_POINT dam = plev * 2 + 99;
			int rad = plev / 5;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_CHAOS, dir, dam, rad);
			}
		}
		break;

	case 16:
		if (name) return _("ҕϗe", "Polymorph Other");
		if (desc) return _("X^[1̂ϐgBRƖB", "Attempts to polymorph a monster.");

		{
			int power = plev;

			if (info) return info_power(power);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				poly_monster(dir, plev);
			}
		}
		break;

	case 17:
		if (name) return _("A", "Chain Lightning");
		if (desc) return _("Sɑ΂ēd̃r[B", "Fires lightning beams in all directions.");

		{
			int dice = 5 + plev / 10;
			int sides = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				for (dir = 0; dir <= 9; dir++)
					fire_beam(GF_ELEC, dir, damroll(dice, sides));
			}
		}
		break;

	case 18:
		if (name) return _("͕", "Arcane Binding");
		if (desc) return _("/@_̏[U񐔂𑝂₷A[Ũbh̏[UԂ炷B", "Recharges staffs, wands or rods.");

		{
			int power = 90;

			if (info) return info_power(power);

			if (cast)
			{
				if (!recharge(power)) return NULL;
			}
		}
		break;

	case 19:
		if (name) return _("q", "Disintegrate");
		if (desc) return _("ȕ̋B", "Fires a huge ball of disintegration.");

		{
			HIT_POINT dam = plev + 70;
			int rad = 3 + plev / 40;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_DISINTEGRATE, dir, dam, rad);
			}
		}
		break;

	case 20:
		if (name) return _("ϗe", "Alter Reality");
		if (desc) return _("݂̊Kč\B", "Recreates current dungeon level.");

		{
			int base = 15;
			int sides = 20;

			if (info) return info_delay(base, sides);

			if (cast)
			{
				alter_reality();
			}
		}
		break;

	case 21:
		if (name) return _("}WbNEPbg", "Magic Rocket");
		if (desc) return _("Pbg𔭎˂B", "Fires a magic rocket.");

		{
			HIT_POINT dam = 120 + plev * 2;
			int rad = 2;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				msg_print(_("PbgˁI", "You launch a rocket!"));
				fire_rocket(GF_ROCKET, dir, dam, rad);
			}
		}
		break;

	case 22:
		if (name) return _("ׂ̐n", "Chaos Branding");
		if (desc) return _("ɃJIX̑B", "Makes current weapon a Chaotic weapon.");

		{
			if (cast)
			{
				brand_weapon(2);
			}
		}
		break;

	case 23:
		if (name) return _("", "Summon Demon");
		if (desc) return _("1̏B", "Summons a demon.");

		{
			if (cast)
			{
				u32b flg = 0L;
				bool pet = !one_in_(3);

				if (pet) flg |= PM_FORCE_PET;
				else flg |= PM_NO_PET;
				if (!(pet && (plev < 50))) flg |= PM_ALLOW_GROUP;

				if (summon_specific((pet ? -1 : 0), p_ptr->y, p_ptr->x, (plev * 3) / 2, SUMMON_DEMON, flg))
				{
					msg_print(_("̈L[B", "The area fills with a stench of sulphur and brimstone."));
					if (pet)
					{
						msg_print(_("upł܂Allv", "'What is thy bidding... Master?'"));
					}
					else
					{
						msg_print(_("uڂ҂Ả͓lɂ炸I O̍𒸂Iv",
							"'NON SERVIAM! Wretch! I shall feast on thy mortal soul!'"));
					}
				}
			}
		}
		break;

	case 24:
		if (name) return _("d͌", "Beam of Gravity");
		if (desc) return _("d͂̃r[B", "Fires a beam of gravity.");

		{
			int dice = 9 + (plev - 5) / 4;
			int sides = 8;

			if (info) return info_damage(dice, sides, 0);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_beam(GF_GRAVITY, dir, damroll(dice, sides));
			}
		}
		break;

	case 25:
		if (name) return _("Q", "Meteor Swarm");
		if (desc) return _("̎ӂ覐΂𗎂ƂB", "Makes meteor balls fall down to nearby random locations.");

		{
			HIT_POINT dam = plev * 2;
			int rad = 2;

			if (info) return info_multi_damage(dam);

			if (cast)
			{
				cast_meteor(dam, rad);
			}
		}
		break;

	case 26:
		if (name) return _("̈ꌂ", "Flame Strike");
		if (desc) return _("𒆐SƂȉ̋𔭐B", "Generate a huge ball of fire centered on you.");

		{
			HIT_POINT dam = 300 + 3 * plev;
			int rad = 8;

			if (info) return info_damage(0, 0, dam / 2);

			if (cast)
			{
				fire_ball(GF_FIRE, 0, dam, rad);
			}
		}
		break;

	case 27:
		if (name) return _("׏", "Call Chaos");
		if (desc) return _("_ȑ̋r[𔭐B", "Generate random kind of balls or beams.");

		{
			if (info) return format("%s150 / 250", s_dam);

			if (cast)
			{
				call_chaos();
			}
		}
		break;

	case 28:
		if (name) return _("ȕϗe", "Polymorph Self");
		if (desc) return _("ϐg悤ƂB", "Polymorphs yourself.");

		{
			if (cast)
			{
				if (!get_check(_("ϐg܂B낵łH", "You will polymorph yourself. Are you sure? "))) return NULL;
				do_poly_self();
			}
		}
		break;

	case 29:
		if (name) return _("̗͂", "Mana Storm");
		if (desc) return _("ɋ͂ŋȏȖ͂̋B", "Fires an extremely powerful huge ball of pure mana.");

		{
			HIT_POINT dam = 300 + plev * 4;
			int rad = 4;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_MANA, dir, dam, rad);
			}
		}
		break;

	case 30:
		if (name) return _("OX̃uX", "Breathe Logrus");
		if (desc) return _("ɋ͂ȃJIX̋B", "Fires an extremely powerful ball of chaos.");

		{
			HIT_POINT dam = p_ptr->chp;
			int rad = 2;

			if (info) return info_damage(0, 0, dam);

			if (cast)
			{
				if (!get_aim_dir(&dir)) return NULL;

				fire_ball(GF_CHAOS, dir, dam, rad);
			}
		}
		break;

	case 31:
		if (name) return _("", "Call the Void");
		if (desc) return _("Ɏ͂ɌāAPbgAȖ͂̋Aːp̋BAǂɗאڂĎgpƍL͈͂j󂷂B",
			"Fires rockets, mana balls and nuclear waste balls in all directions each unless you are not adjacent to any walls. Otherwise *destroys* huge area.");

		{
			if (info) return format("%s3 * 175", s_dam);

			if (cast)
			{
				call_the_();
			}
		}
		break;
	}

	return "";
}